/* ==========================================================
 *                  GitGraph v1.0.0
 *      https://github.com/nicoespeon/gitgraph.js
 * ==========================================================
 * Copyright (c) 2016 Nicolas CARLO (@nicoespeon) ٩(^‿^)۶
 * Copyright (c) 2016 Fabien BERNARD (@fabien0102) ✌(✰‿✰)✌
 *
 * GitGraph.js may be freely distributed under the MIT Licence
 * ========================================================== */
!(function() {
  "use strict";
  function a(a) {
    switch (
      ((a = "object" == typeof a ? a : {}),
      (this.elementId =
        "string" == typeof a.elementId ? a.elementId : "gitGraph"),
      (this.author =
        "string" == typeof a.author
          ? a.author
          : "Sergio Flores <saxo-guy@epic.com>"),
      "string" == typeof a.template &&
        (a.template = this.newTemplate(a.template)),
      (this.template =
        a.template instanceof d ? a.template : this.newTemplate("metro")),
      (this.mode = a.mode || null),
      "compact" === this.mode && (this.template.commit.message.display = !1),
      (this.marginX = 2 * this.template.commit.dot.size),
      (this.marginY = 2 * this.template.commit.dot.size),
      (this.offsetX = 0),
      (this.offsetY = 0),
      a.orientation)
    ) {
      case "vertical-reverse":
        (this.template.commit.spacingY *= -1),
          (this.orientation = "verticale-reverse");
        break;
      case "horizontal":
        (this.template.commit.message.display = !1),
          (this.template.commit.spacingX = this.template.commit.spacingY),
          (this.template.branch.spacingY = this.template.branch.spacingX),
          (this.template.commit.spacingY = 0),
          (this.template.branch.spacingX = 0),
          (this.orientation = "horizontal");
        break;
      case "horizontal-reverse":
        (this.template.commit.message.display = !1),
          (this.template.commit.spacingX = -this.template.commit.spacingY),
          (this.template.branch.spacingY = this.template.branch.spacingX),
          (this.template.commit.spacingY = 0),
          (this.template.branch.spacingX = 0),
          (this.orientation = "horizontale-reverse");
        break;
      default:
        this.orientation = "vertical";
    }
    (this.canvas = document.getElementById(this.elementId) || a.canvas),
      (this.context = this.canvas.getContext("2d")),
      (this.tooltip = document.createElement("div")),
      (this.tooltip.className = "gitgraph-tooltip"),
      (this.tooltip.style.position = "fixed"),
      (this.tooltip.style.display = "none"),
      document.body.appendChild(this.tooltip),
      (this.HEAD = null),
      (this.branchs = []),
      (this.commits = []),
      (this.columnMax = 0),
      (this.commitOffsetX = 0),
      (this.commitOffsetY = 0),
      (this.lasthover = null),
      this.template.commit.message.display ||
        this.canvas.addEventListener(
          "mousemove",
          { handleEvent: this.hover, gitgraph: this },
          !1,
        );
    var b = this;
    window.onresize = function() {
      b.render();
    };
  }
  function b(b) {
    b.parent instanceof a != !1 &&
      ((b = "object" == typeof b ? b : {}),
      (this.parent = b.parent),
      (this.parentBranch = b.parentBranch),
      (this.name = "string" == typeof b.name ? b.name : "no-name"),
      (this.context = this.parent.context),
      (this.template = this.parent.template),
      (this.lineWidth = this.template.branch.lineWidth),
      (this.spacingX = this.template.branch.spacingX),
      (this.spacingY = this.template.branch.spacingY),
      (this.size = 0),
      (this.height = 0),
      (this.width = 0),
      (this.commits = []),
      (this.path = []),
      (this.column = 0),
      this.calculColumn(),
      (this.offsetX = this.column * this.spacingX),
      (this.offsetY = this.column * this.spacingY),
      (this.color =
        b.color ||
        this.template.branch.color ||
        this.template.colors[this.column]),
      this.checkout());
  }
  function c(b) {
    b.parent instanceof a != !1 &&
      ((b = "object" == typeof b ? b : {}),
      (this.parent = b.parent),
      (this.template = this.parent.template),
      (this.context = this.parent.context),
      (this.branch = b.branch),
      (this.author = b.author || this.parent.author),
      (this.date = b.date || new Date().toUTCString()),
      (this.detail = b.detail || null),
      (this.sha1 =
        b.sha1 ||
        Math.random(100)
          .toString(16)
          .substring(3, 10)),
      (this.message = b.message || "He doesn't like George Michael! Boooo!"),
      (this.arrowDisplay = b.arrowDisplay),
      (this.messageDisplay =
        b.messageDisplay || this.template.commit.message.display),
      (this.messageColor = b.messageColor || b.color),
      (this.dotColor = b.dotColor || b.color),
      (this.dotSize = b.dotSize || this.template.commit.dot.size),
      (this.dotStrokeWidth =
        b.dotStrokeWidth || this.template.commit.dot.strokeWidth),
      (this.dotStrokeColor =
        b.dotStrokeColor || this.template.commit.dot.strokeColor || b.color),
      (this.type = b.type || null),
      (this.parentCommit = b.parentCommit),
      (this.x = b.x),
      (this.y = b.y),
      this.parent.commits.push(this));
  }
  function d(a) {
    (a = "object" == typeof a ? a : {}),
      (a.branch = a.branch || {}),
      (a.arrow = a.arrow || {}),
      (a.commit = a.commit || {}),
      (a.commit.dot = a.commit.dot || {}),
      (a.commit.message = a.commit.message || {}),
      (this.colors = a.colors || [
        "#6963FF",
        "#47E8D4",
        "#6BDB52",
        "#E84BA5",
        "#FFA657",
      ]),
      (this.branch = {}),
      (this.branch.color = a.branch.color || null),
      (this.branch.lineWidth = a.branch.lineWidth || 2),
      (this.branch.mergeStyle = a.branch.mergeStyle || "bezier"),
      (this.branch.spacingX =
        "number" == typeof a.branch.spacingX ? a.branch.spacingX : 20),
      (this.branch.spacingY = a.branch.spacingY || 0),
      (this.arrow = {}),
      (this.arrow.size = a.arrow.size || null),
      (this.arrow.color = a.arrow.color || null),
      (this.arrow.active = "number" == typeof this.arrow.size),
      (this.arrow.offset = a.arrow.offset || 2),
      (this.commit = {}),
      (this.commit.spacingX = a.commit.spacingX || 0),
      (this.commit.spacingY =
        "number" == typeof a.commit.spacingY ? a.commit.spacingY : 25),
      (this.commit.color = a.commit.color || null),
      (this.commit.dot = {}),
      (this.commit.dot.color = a.commit.dot.color || null),
      (this.commit.dot.size = a.commit.dot.size || 3),
      (this.commit.dot.strokeWidth = a.commit.dot.strokeWidth || null),
      (this.commit.dot.strokeColor = a.commit.dot.strokeColor || null),
      (this.commit.message = {}),
      (this.commit.message.display =
        "boolean" == typeof a.commit.message.display
          ? a.commit.message.display
          : !0),
      (this.commit.message.color = a.commit.message.color || null),
      (this.commit.message.font =
        a.commit.message.font || "normal 12pt Calibri");
  }
  (a.prototype.branch = function(a) {
    if ("string" == typeof a) {
      var c = a;
      (a = {}), (a.name = c);
    }
    (a = "object" == typeof a ? a : {}),
      (a.parent = this),
      (a.parentBranch = a.parentBranch || this.HEAD);
    var d = new b(a);
    return this.branchs.push(d), d;
  }),
    (a.prototype.orphanBranch = function(a) {
      if ("string" == typeof a) {
        var c = a;
        (a = {}), (a.name = c);
      }
      (a = "object" == typeof a ? a : {}), (a.parent = this);
      var d = new b(a);
      return this.branchs.push(d), d;
    }),
    (a.prototype.commit = function(a) {
      return this.HEAD.commit(a), this;
    }),
    (a.prototype.newTemplate = function(a) {
      return "string" == typeof a ? new d().get(a) : new d(a);
    }),
    (a.prototype.render = function() {
      (this.canvas.height =
        Math.abs(this.columnMax * this.template.branch.spacingY) +
        Math.abs(this.commitOffsetY) +
        2 * this.marginY),
        (this.canvas.width =
          Math.abs(this.columnMax * this.template.branch.spacingX) +
          Math.abs(this.commitOffsetX) +
          2 * this.marginX),
        this.template.commit.message.display && (this.canvas.width += 800),
        this.context.clearRect(0, 0, this.canvas.width, this.canvas.height),
        this.context.translate(this.marginX, this.marginY),
        this.template.commit.spacingY > 0 &&
          (this.context.translate(0, this.canvas.height - 2 * this.marginY),
          (this.offsetY = this.canvas.height - 2 * this.marginY)),
        this.template.commit.spacingX > 0 &&
          (this.context.translate(this.canvas.width - 2 * this.marginX, 0),
          (this.offsetX = this.canvas.width - 2 * this.marginX));
      for (var a, b = this.branchs.length - 1; (a = this.branchs[b]); b--)
        a.render();
      for (var c, d = 0; (c = this.commits[d]); d++) c.render();
    }),
    (a.prototype.hover = function(a) {
      var b = this.gitgraph,
        c = 0,
        d = !0;
      (a.offsetX = a.offsetX ? a.offsetX : a.layerX),
        (a.offsetY = a.offsetY ? a.offsetY : a.layerY),
        (a.x = a.x ? a.x : a.clientX),
        (a.y = a.y ? a.y : a.clientY);
      for (var e, f = 0; (e = this.gitgraph.commits[f]); f++)
        (c = Math.sqrt(
          (e.x + b.offsetX + b.marginX - a.offsetX) *
            (e.x + b.offsetX + b.marginX - a.offsetX) +
            (e.y + b.offsetY + b.marginY - a.offsetY) *
              (e.y + b.offsetY + b.marginY - a.offsetY),
        )),
          c < b.template.commit.dot.size &&
            ((b.tooltip.style.left = a.x + "px"),
            (b.tooltip.style.top = a.y + "px"),
            (b.tooltip.textContent = e.sha1 + " - " + e.message),
            (b.tooltip.style.display = "block"),
            (d = !1));
      d && (b.tooltip.style.display = "none");
    }),
    (b.prototype.branch = function(a) {
      if ("string" == typeof a) {
        var c = a;
        (a = {}), (a.name = c);
      }
      (a = "object" == typeof a ? a : {}),
        (a.parent = this.parent),
        (a.parentBranch = a.parentBranch || this);
      var d = new b(a);
      return this.parent.branchs.push(d), d;
    }),
    (b.prototype.render = function() {
      this.context.beginPath();
      for (var a, b = 0; (a = this.path[b]); b++)
        "start" === a.type
          ? this.context.moveTo(a.x, a.y)
          : "bezier" === this.template.branch.mergeStyle
            ? this.context.bezierCurveTo(
                this.path[b - 1].x - this.template.commit.spacingX / 2,
                this.path[b - 1].y - this.template.commit.spacingY / 2,
                a.x + this.template.commit.spacingX / 2,
                a.y + this.template.commit.spacingY / 2,
                a.x,
                a.y,
              )
            : this.context.lineTo(a.x, a.y);
      (this.context.lineWidth = this.lineWidth),
        (this.context.strokeStyle = this.color),
        this.context.stroke(),
        this.context.closePath();
    }),
    (b.prototype.commit = function(a) {
      if ("string" == typeof a) {
        var d = a;
        (a = {}), (a.message = d);
      } else "object" != typeof a && (a = {});
      (a.arrowDisplay = this.template.arrow.active),
        (a.branch = this),
        (a.color =
          a.color ||
          this.template.commit.color ||
          this.template.colors[this.column]),
        (a.parent = this.parent),
        (a.parentCommit = a.parentCommit || this.commits.slice(-1)[0]),
        "compact" === this.parent.mode &&
          this.parent.commits.slice(-1)[0] &&
          this.parent.commits.slice(-1)[0].branch !== a.branch &&
          a.branch.commits.length &&
          "mergeCommit" !== a.type &&
          ((this.parent.commitOffsetX -= this.template.commit.spacingX),
          (this.parent.commitOffsetY -= this.template.commit.spacingY)),
        (a.messageColor =
          a.messageColor ||
          a.color ||
          this.template.commit.message.color ||
          null),
        (a.dotColor =
          a.dotColor || a.color || this.template.commit.dot.color || null),
        (a.x = this.offsetX - this.parent.commitOffsetX),
        (a.y = this.offsetY - this.parent.commitOffsetY),
        (a.detail =
          "string" == typeof a.detailId &&
          "vertical" === this.parent.orientation &&
          "compact" !== this.parent.mode
            ? document.getElementById(a.detailId)
            : null),
        a.branch.commits.slice(-1)[0] &&
          a.x + a.y ===
            a.branch.commits.slice(-1)[0].x + a.branch.commits.slice(-1)[0].y &&
          ((this.parent.commitOffsetX += this.template.commit.spacingX),
          (this.parent.commitOffsetY += this.template.commit.spacingY),
          (a.x = this.offsetX - this.parent.commitOffsetX),
          (a.y = this.offsetY - this.parent.commitOffsetY)),
        a.parentCommit instanceof c == !1 &&
          this.parentBranch instanceof b &&
          (a.parentCommit = this.parentBranch.commits.slice(-1)[0]);
      var e = new c(a);
      this.commits.push(e);
      var f = { x: e.x, y: e.y, type: "join" };
      if (e.parentCommit instanceof c && 0 === this.path.length) {
        var g = {
          x:
            e.parentCommit.branch.offsetX -
            this.parent.commitOffsetX +
            this.template.commit.spacingX,
          y:
            e.parentCommit.branch.offsetY -
            this.parent.commitOffsetY +
            this.template.commit.spacingY,
          type: "start",
        };
        this.path.push(JSON.parse(JSON.stringify(g))),
          (g.type = "join"),
          this.parentBranch.path.push(g);
      } else 0 === this.path.length && (f.type = "start");
      return (
        this.path.push(f),
        (this.parent.commitOffsetX += this.template.commit.spacingX),
        (this.parent.commitOffsetY += this.template.commit.spacingY),
        null !== e.detail &&
          ((e.detail.style.display = "block"),
          (this.parent.commitOffsetY -= e.detail.clientHeight - 40)),
        this.parent.render(),
        this
      );
    }),
    (b.prototype.checkout = function() {
      this.parent.HEAD = this;
    }),
    (b.prototype.delete = function() {
      this.isfinish = !0;
    }),
    (b.prototype.merge = function(a, c) {
      var d = a || this.parent.HEAD;
      if (d instanceof b != !1 && d !== this) {
        var e = c;
        (c = c || {}),
          (c.message =
            c.message ||
            ("string" == typeof e
              ? e
              : "Merge branch `" + this.name + "` into `" + d.name + "`")),
          (c.type = "mergeCommit"),
          (c.parentCommit = this.commits.slice(-1)[0]),
          d.commit(c);
        var f = {
          x:
            this.offsetX +
            2 * this.template.commit.spacingX -
            this.parent.commitOffsetX,
          y:
            this.offsetY +
            2 * this.template.commit.spacingY -
            this.parent.commitOffsetY,
          type: "join",
        };
        this.path.push(JSON.parse(JSON.stringify(f)));
        var g = {
          x: d.commits.slice(-1)[0].x,
          y: d.commits.slice(-1)[0].y,
          type: "end",
        };
        return (
          this.path.push(g),
          (f.type = "start"),
          this.path.push(f),
          this.parent.render(),
          (this.parent.HEAD = d),
          this
        );
      }
    }),
    (b.prototype.calculColumn = function() {
      for (var a, b = 0; (a = this.parent.branchs[b]) && !a.isfinish; b++)
        this.column++;
      this.parent.columnMax =
        this.column > this.parent.columnMax
          ? this.column
          : this.parent.columnMax;
    }),
    (c.prototype.render = function() {
      if (
        (this.context.beginPath(),
        this.context.arc(this.x, this.y, this.dotSize, 0, 2 * Math.PI, !1),
        (this.context.fillStyle = this.dotColor),
        (this.context.strokeStyle = this.dotStrokeColor),
        (this.context.lineWidth = this.dotStrokeWidth),
        "number" == typeof this.dotStrokeWidth && this.context.stroke(),
        this.context.fill(),
        this.context.closePath(),
        this.arrowDisplay && this.parentCommit instanceof c && this.arrow(),
        null !== this.detail &&
          ((this.detail.style.left =
            this.parent.canvas.offsetLeft +
            (this.parent.columnMax + 1) * this.template.branch.spacingX +
            30 +
            "px"),
          (this.detail.style.top =
            this.parent.canvas.offsetTop + this.y + 40 + "px"),
          (this.detail.width = 30)),
        this.messageDisplay)
      ) {
        var a =
          this.sha1 +
          " " +
          this.message +
          (this.author ? " - " + this.author : "");
        (this.context.font = this.template.commit.message.font),
          (this.context.fillStyle = this.messageColor),
          this.context.fillText(
            a,
            (this.parent.columnMax + 1) * this.template.branch.spacingX,
            this.y + 3,
          );
      }
    }),
    (c.prototype.arrow = function() {
      var a = this.template.arrow.size,
        b = this.template.arrow.color || this.branch.color,
        c = Math.atan2(
          this.parentCommit.y - this.y,
          this.parentCommit.x - this.x,
        );
      ("mergeCommit" === this.type || this === this.branch.commits[0]) &&
        ((c = Math.atan2(
          this.template.branch.spacingY *
            (this.parentCommit.branch.column - this.branch.column) +
            this.template.commit.spacingY,
          this.template.branch.spacingX *
            (this.parentCommit.branch.column - this.branch.column) +
            this.template.commit.spacingX,
        )),
        (b = this.parentCommit.branch.color));
      var d = Math.PI / 7,
        e = this.template.commit.dot.size + this.template.arrow.offset,
        f = e * Math.cos(c) + this.x,
        g = e * Math.sin(c) + this.y,
        h = (e + a) * Math.cos(c - d) + this.x,
        i = (e + a) * Math.sin(c - d) + this.y,
        j = (e + a / 2) * Math.cos(c) + this.x,
        k = (e + a / 2) * Math.sin(c) + this.y,
        l = (e + a) * Math.cos(c + d) + this.x,
        m = (e + a) * Math.sin(c + d) + this.y;
      this.context.beginPath(),
        (this.context.fillStyle = b),
        this.context.moveTo(f, g),
        this.context.lineTo(h, i),
        this.context.quadraticCurveTo(j, k, l, m),
        this.context.lineTo(l, m),
        this.context.fill();
    }),
    (d.prototype.get = function(a) {
      switch (a) {
        case "blackarrow":
          return new d({
            branch: {
              color: "#000000",
              lineWidth: 4,
              spacingX: 50,
              mergeStyle: "straight",
            },
            commit: {
              spacingY: -60,
              dot: { size: 12, strokeColor: "#000000", strokeWidth: 7 },
              message: { color: "black" },
            },
            arrow: { size: 16, offset: 2.5 },
          });
        case "metro":
          return new d({
            colors: ["#979797", "#008fb5", "#f1c109"],
            branch: { lineWidth: 10, spacingX: 50 },
            commit: {
              spacingY: -80,
              dot: { size: 14 },
              message: { font: "normal 14pt Arial" },
            },
          });
      }
    }),
    (window.GitGraph = a);
})();
